program Lib7zS2_Test_Simple;

{$APPTYPE CONSOLE}

uses
  Windows;

function ExeNameA:AnsiString;
var Buffer:array[0..MAX_PATH+1] of AnsiChar;
begin
  Buffer[MAX_PATH+1]:=#0;
  GetModuleFileName(hInstance,Buffer,MAX_PATH+1);
  Result:=Buffer;
end;

function ExtractFilePathA(const Path:AnsiString):String;
var i,p:Integer;
begin
  p:=0;
  for i:=1 to Length(Path) do if Path[i]='\' then p:=i;
  if (p>0) then Result:=Copy(Path,1,p) else Result:='';
end;

function DoUn7z(fn:AnsiString='?';outdir:AnsiString='.\';hPb:Hwnd=0):Integer;
var
  h:THandle;
  un7zproc:function(Prm1,Prm2:PWideChar;Pmr3:Hwnd):integer;cdecl;
begin
  Result:=-1;
  h:=LoadLibrary(PChar( ExtractFilePathA(ExeNameA)+'Lib7zS2.dll' ));
  if h<=0 then Exit;
  @un7zproc:=GetProcAddress(h,'Extract7zW');
  if @un7zproc=nil then Exit;
  if fn<>'?'
    then Result:=un7zproc(PWideChar(WideString(fn)),PWideChar(WideString(outdir)),hPb)
    else Result:=0;
  FreeLibrary(h);
end;

begin
  WriteLn('Lib7zS2 loaded = ',(DoUn7z()=0));
  WriteLn('Result = ', DoUn7z(ExtractFilePathA(ExeNameA)+'Test.7z',ExtractFilePathA(ExeNameA),0) , ' (0=ok!)') ;
  ReadLn;
end.
